#! /user/bin/python
# _*_ coding:UTF-8 _*_
import os
from abaqus import *
from abaqusConstants import *
from odbAccess import *
from abaqusConstants import *
import numpy as np
import xlwt
import re

#目标路径
dir1=r'D:\cz_\ODB_TEST'#引号中的dir为指定文件夹

#获取该路径下所有文件的名称
names=os.listdir(dir1)
print(names)

# 建立储存文件名的矩阵进行文件过滤
inpfile=[]
odbfile=[]
print(inpfile)
print(odbfile)

#循环得到相应的文件名并添加到对应的文件名矩阵中
for name in names:
    if name.endswith('.inp'):
        inpfile.append(name)
    else:
        if name.endswith('.odb'):
           odbfile.append(name)
        else:
            pass
        pass
print(inpfile)
print(odbfile)
str = ''
data=[]
for q in odbfile:
    bh = []
    myodb = session.openOdb(name=q, readOnly=False)
    #提应变
    session.viewports['Viewport: 1'].setValues(displayedObject=myodb)
    session.viewports['Viewport: 1'].odbDisplay.setPrimaryVariable(
        variableLabel='E', outputPosition=INTEGRATION_POINT, refinement=(COMPONENT,
                                                                         'E33'), )
    session.viewports['Viewport: 1'].odbDisplay.display.setValues(plotState=(
        CONTOURS_ON_UNDEF,))
    session.Path(name='Path-1', type=NODE_LIST, expression=(('PART-76-1', (
        58847,  58869,  58891,  61460,  61482,  
         61504,  64181,  64203,  64225,  66776,  
         66798,  66820,  69398,  69420,  69442,  
         73061,  73081,  73101,  75881,  75901,  
         75921,  78682,  78702,  78722,  81475,  
         81495,  81515,  84241,  84261,  84281,  
         88412,  88432,  88452,  90994,  91014,  
         91034,  93576,  93596,  93616,  96158,  
         96178,  96198,  98943,  98963,  98983, 
         101764, 101784, 101804, 104594, 104614, 
         104634, 107424, 107444, 107464, 110227, 
         110247, 110267, 113206, 113226, 113246)), ))
    pth1 = session.paths['Path-1']
    session.XYDataFromPath(name='bh_s', path=pth1, includeIntersections=False,
                           projectOntoMesh=False, pathStyle=PATH_POINTS, numIntervals=10,
                           projectionTolerance=0, shape=UNDEFORMED, labelType=SEQ_ID,
                           removeDuplicateXYPairs=True, includeAllElements=False)

    def B_list():
        for b in session.xyDataObjects['bh_s']:
            b_a = b[1]
            bh.append(b_a)
        
        return bh
    a = B_list()
    data.append(a)
    #str = str+q+' '
    #data.append((str))
    myodb.close()
wb = xlwt.Workbook()
ws = wb.add_sheet('data_1')
j = len(data)
c = 0
l = len(data[0])
k = 0
print(j)
print(l)
#print(data.shape)
#while c<j :
while c < j :
    for k in range(60) :
        ws.write(c, k, data[c][k])
    c = c+1
    #k = k+1
#ws.write()
#print(str)
#qd = str.split()
#print(qd)
wb.save('cz-1.xls')
print(didi)

